#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>

#include "gmp.h"

int main(int argc, char **argv)
{
#define BASEDESTNAME	"stegoclick_temp"
	FILE *dest, *source;
	int i, sizeout, counter =0;
	char destname[MAXPATHLEN];
	char *smap, *dmap;
	mpz_t filein;

	/* ./file2click sourcefile, sourcebytelen, maxnumber, random */
	if(argc != 5)
		return printf("%s is called from stegoclick.sh, go away!\n", *argv);

	snprintf(destname, MAXPATHLEN, "%s.%s.click", BASEDESTNAME, argv[4]);

	if((source =fopen(argv[1], "r")) == NULL)
		return printf("%s unable to open %s\n", argv[0], argv[1]);
	if((smap =calloc(atoi(argv[2]), 2)) ==NULL)
		return printf("unable to malloc %d bytes\n", atoi(argv[2]) * 2);

	/* smap contain hexdecimal dump of file */
	for(i =0; i < atoi(argv[2]); i++)
	{
		int c =fgetc(source);
		sprintf(&smap[i * 2], "%02x", (unsigned char)c);
	}
	smap[(i * 2) -1] =0x00;
	fprintf(stderr, "hexdecimal block:\n%s\n", smap);
	fprintf(stderr, "hexdecimal source %d bytes, length: %d (strlen %d)\n", 
		i, i * 2, strlen(smap)
	);

	mpz_init(filein);
	mpz_set_str(filein, smap, 16);
	/* smap is aquire as base-16 number in FILEIN */

	if((dest =fopen(destname, "w+")) ==NULL)
		return printf("%s unable to create %s\n", argv[0], destname);

	mpz_out_str(dest, 9, filein);
	sizeout =mpz_sizeinbase(filein, 9);
	/* FILEIN is converted in base-9 number in $destname file */

	if((dmap =malloc(sizeout)) ==NULL)
		return printf("unable to alloc %d bytes\n", sizeout + 10);

	/* 
	 * setting default to decimal '0' for fill ending payload,
	 * also if valuelen check this crap, avoiding the '0'.
	 */
	memset(dmap, '0', sizeout);
	fseek(dest, SEEK_SET, 0);
	fread(dmap, sizeout, 1, dest);

	/* seeking 0 and close don't write any file, after I unlink */
	fseek(dest, SEEK_SET, 0);
	fclose(dest);
	unlink(destname);

	/* 
	 * this because for read as decimal number, I must drop the "0",
	 * except the last 10 "0" memset before
	 */
	dmap[sizeout] =0x00;
	fprintf(stderr, "base-9 with original value (%d):\n%s\n", sizeout, dmap);
	for(i =0; i < sizeout; i++)
		if(dmap[i] == '0')
			dmap[i] ='9';
	fprintf(stderr, "base-9 with 9 insted of 0 (%d):\n%s\n", sizeout, dmap);

	fprintf(stderr, "base-9 fragmentation:\n");
	for(i =0; i < sizeout; )
	{
		char number[1024];
		int valuelen;

		memset(number, 0, 1024);

		if(dmap[i] < argv[3][0])
		{
			valuelen =strlen(argv[3]);
			if(valuelen > (sizeout - i))
				valuelen = (sizeout - i);

			memcpy(number, &dmap[i], valuelen);
			i += valuelen;
		}
		else
		{
			valuelen =(strlen(argv[3]) -1);
			if(valuelen > (sizeout - i))
				valuelen = (sizeout - i);

			memcpy(number, &dmap[i], valuelen);
			i += valuelen;
		}
		printf("%s\n", number);
		fprintf(stderr, "number %d sum %d value: %s\n", ++counter, i, number);
	}

	return 0;
}
