#!/bin/sh 

function append_linevalue
{
# $tempvalium: incremental number for unique clickstegosession
# $ip: actual parsed IP address
# $ig: ip+get line under analysis
	name=`echo "extractclick.$ip.$tempvalium"`
	geturl=`echo $ig | sed -es/.*get\ \\\/ep-mirror\\\///g | grep html | cut -d " " -f -1`
	refer=`echo $ig | sed -es/.*http.*ep-mirror\\\///g | grep html | cut -d " " -f -1`
	if [ -z $geturl ] || [ -z $refer ]; then
#		echo "string error ? $ip $ig $actual $geturl $refer"
		return
	fi
	value=`grep -i "$refer $geturl" stegocode.list | cut -f 1`
	if [ -z $value ]; then
		echo "value error ? $ip $ig $actual $geturl $refer"
	fi
	echo -n "$value" >> $name
}

echo -ne "[+] stegoreader.sh, part of stegoclick project: http://www.delirandom.net\n"
if [ $1 == "" ]; then
	echo -ne "[-] first argument: the logfile!\n"
	exit
fi

echo -ne "[+] cleaning extractclick.* files\n"
rm -rf extractclick.*

echo -ne "[+] checking for stegocode.list required file\n"
if [ ! -f stegocode.list ]; then
	echo "[-] stegocode.list doesn't exist, and I'm require it, please read README"
	exit
fi

echo -ne "[+] checking baseurl and index file...\n"
if [ $2 == "" ]; then
	echo -ne "[-] bad argument: I'm looking for baseurl/index-like-file.html"
	exit
fi

ndxfile=`basename $2`
basenam=`echo $2 | sed -e's/\/.*//g'`
echo -ne "[+] basename $basenam and index file $ndxfile, parsing $1 ...\n"

uniqip=`grep $ndxfile $1 | sort | awk {' print $1 '} | uniq`

tempvalium=1
echo -ne "[+] for each unique IP asking for $ndxfile, get him history\n"
for ip in $uniqip; 
	do 
	ipgets=`grep $ip $1 | grep $basenam | tr [:upper:] [:lower:] | \
		sed -e's/"//g' -e's/^/V/g'`
	IFS='V'
	for ig in $ipgets;
		do 
		checkdelim=`echo $ig | grep -c $ndxfile`
		if [ $checkdelim == "1" ]; then
			tempvalium=$(($tempvalium + 1))
			echo -n "."
		else
			append_linevalue
		fi
		done
	done

echo -en "\n[+] built $tempvalium files to analyze (tempfile like extractclick.*)\n"
rm -f click2file.debug.out
IFS='e'
filez=`ls extractclick.*`
for phile in $filez; # this crap because IFS is not more default, I must learn bash better
	do
	phile=`echo "e$phile"`
	if [ -e "$phile" ]; then
		echo -en "[+] analysis of $phile... "
		sed -e's/\ //g' "$phile" > `echo $phile.strip`
		mv `echo $phile.strip` "$phile"
		filelen=`wc -c < $phile`
		./click2file "$phile" $filelen 2>>click2file.debug.out
		echo -en "OK\n"
	fi
	done

echo -en "[+] cleaning temp extractclick.* files...\n"
rm -f extractclick.*
echo -en "[+] generated file has this file magic number:\n\n"
file clicked_data.*
